/* Edmundas Vasonskis, 6 grupe, II kursas, Informatika */

/*
3 UZDUOTIS
5var.
Realizuoti dvieju aibiu skirtumo ir simetrinio skirtumo operacijas,
kai kiekviena is aibiu yra isreiksta atskiru raudonai-juodu medziu.
*/

#include <iostream>
#include "3uzd_5var.h"
using namespace std;

RBTree* RBTreeCreate()
{
    RBTree* newTree;
    RBTreeNode* node;
    
    newTree = (RBTree*) malloc(sizeof(RBTree));
    node = newTree -> z = (RBTreeNode*) malloc (sizeof(RBTreeNode));
    node -> left = node;
    node -> right = node;
    node -> red = 0;
    node = newTree -> head = (RBTreeNode*) malloc (sizeof(RBTreeNode));
    node -> key = 0;
    node -> right = newTree -> z;
    
    return newTree;
}        

RBTreeNode* insert(RBTree* tree, int v)
{
    RBTreeNode* gg; // prosenelio nuoroda
    RBTreeNode* g;  // senelio nuoroda
    RBTreeNode* p;  // parent - tevo nuoroda
    
    RBTreeNode* x;  // tai bus iterpta virsune
    
    x = tree -> head;
    
    p = x; g = x;
    
    do{
        gg = g; g = p; p = x;
        if (v < x -> key)
             x = x -> left;
        else
             x = x -> right;
        
        if ( (x -> left -> red) & (x -> right -> red) )
             x = split(tree,v,gg,g,p,x);
    } 
    while (x!= tree -> z);
    
    x = (RBTreeNode*) malloc (sizeof(RBTreeNode));
    x -> key = v;
    x -> left = tree -> z;
    x -> right = tree -> z;
    
    if (v < p -> key)
         p -> left = x;
    else
         p -> right = x;
         
    return x;
    
    x = split(tree,v,gg,g,p,x);
}    

RBTreeNode* rotate(int v, RBTreeNode* y)
{
    RBTreeNode* c;
    RBTreeNode* gc;
    
    if (v < y -> key) c = y -> left;
    else c = y -> right;
    
    if (v < c -> key){
        gc = c -> left;
        c -> left = gc -> right;
        gc -> right = c;
    }    
    else{
        gc = c -> right;
        c -> right = gc -> left;
        gc -> left = c;
    }
    
    if (v < y -> key) y -> left = gc;
    else y -> right = gc;
    
    return gc;    
}    

RBTreeNode* split(RBTree* tree, int v, RBTreeNode* gg, RBTreeNode* g, RBTreeNode* p, RBTreeNode* x)
{
    x -> red = 1;
    x -> left -> red = 0;
    x -> right -> red = 0;
    
    if (p -> red){
        g -> red = 1;
        if ( (v < g -> key) != (v < p -> key) )
               p = rotate(v,g);
        x = rotate(v,gg);
        x -> red = 0;
    }
    
    tree -> head -> right -> red = 0;
    
    return x;    
} 

void printnode(RBTreeNode* x)
{
    cout << x -> key;
    //cout << x -> info;
    cout << " ";
} 

void treeprint(RBTree* tree, RBTreeNode* x)
{
    if (x != tree -> z){
        treeprint(tree, x -> left);
        printnode(x);
        treeprint(tree, x -> right);
    }
}

void TreeSearch(RBTree* tree, RBTreeNode* node, RBTreeNode* x)
{    
    if ( node != tree -> z ){
        TreeSearch(tree, node -> left, x);
        if ( x -> key == node -> key ){
             rastas = true;
             return;
         }    
        TreeSearch(tree, node -> right, x);        
    }   
}

void TreeTraverse(RBTree* tree1, RBTree* tree2, RBTreeNode* x, bool simetrinis)
{
    if (x != tree1 -> z){
    	TreeTraverse(tree1, tree2, x -> left, simetrinis);
    	
    	rastas = false;	
        TreeSearch(tree2, tree2 -> head -> right, x);
        
    	if (!rastas) // tinka tik elementai, kuriu nera kitoje aibeje
    	     if (simetrinis) insert(sim_skir_medis, x -> key);
    	     else insert(skirt_medis, x -> key);
    	     //cout << x -> key << "\n";
        
    	TreeTraverse(tree1, tree2, x -> right, simetrinis);
    }
}
    

int main(){
    
    RBTree* tree;
    RBTree* tree2;
    //RBTree* skirt_medis;
    //RBTree* sim_skir_medis;
     
    tree = RBTreeCreate();
      
    for (int i=2; i <= 30; i++){
        insert(tree, i); 
    }

    treeprint(tree, tree -> head -> right); // head -> right - visada ziuri i medzio sakni!  
    cout << "\n";    
    
    tree2 = RBTreeCreate();
    
    for (int i=5; i <= 20; i++){
        insert(tree2, i); 
    }
    for (int i=40; i <= 45; i++){
        insert(tree2, i); 
    }
    
    treeprint(tree2, tree2 -> head -> right);
    
    cout << "\nAibiu skirtumas: " << "\n";
    skirt_medis = RBTreeCreate();
    TreeTraverse(tree,tree2, tree -> head -> right, false);
    treeprint(skirt_medis, skirt_medis -> head -> right);
    
    cout << "\nAibiu simetrinis skirtumas: " << "\n";
    sim_skir_medis = RBTreeCreate();
    TreeTraverse(tree,tree2, tree -> head -> right, true);
    TreeTraverse(tree2,tree, tree2 -> head -> right, true);
    treeprint(sim_skir_medis, sim_skir_medis -> head -> right);
    cout << "\n";
    
    return 0;

} //end main()
